/////////////////////////////////////////////////////////////
//                                                         //
// Copyright (c) 2007-2011 by The University of Queensland //
// Earth Systems Science Computational Centre (ESSCC)      //
// http://www.uq.edu.au/esscc                              //
//                                                         //
// Primary Business: Brisbane, Queensland, Australia       //
// Licensed under the Open Software License version 3.0    //
// http://www.opensource.org/licenses/osl-3.0.php          //
//                                                         //
/////////////////////////////////////////////////////////////

#ifndef __CYLINDERWITHJOINTSET_H
#define __CYLINDERWITHJOINTSET_H

// --- Project includes ---
#include "CylinderVol.h"
#include "Plane.h"
#include "TriPatchSet.h"
#include "Triangle3D.h"

// --- STL includes ---
#include <vector>
#include <map>

using std::vector;
using std::map;

class CylinderWithJointSet : public CylinderVol
{
 protected:
  vector<Triangle3D> m_joints;

 public:
  CylinderWithJointSet();
  CylinderWithJointSet(const Vector3&,const Vector3&,double,double);
  virtual ~CylinderWithJointSet(){};

  virtual const map<double,const AGeometricObject*> getClosestObjects(const Vector3&,int) const;
  void addJoints(const TriPatchSet&);
  virtual bool isIn(const Sphere&);
 
  friend ostream& operator << (ostream&,const CylinderWithJointSet&);
};

#endif // __CYLINDERWITHJOINTSET_H
